/*
** main.c
*/
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include <stdlib.h>
#include "lcd.h"

int main(void)
{	
	// Setup LCD
	lcd_init();
	lcd_contrast(0x40);

	// Setup Game
	int player1_y = 1;
	int player2_y = 1;
	int ball_x = 7;
	int ball_y = 3;
	int direction_x = 0;
	int direction_y = 0;
	int score_1 = 0;
	int score_2 = 0;
	char* buffer;
	int r = 0; 
	
	switch(r){
		case 0:
			direction_x = -1;
			direction_y = -1;
			r = 1;
			break;
		case 1:
			direction_x = -1;
			direction_y = 1;
			r = 2;
			break;
		case 2:
			direction_x = 1;
			direction_y = -1;
			r = 3;
			break;
		case 3:
			direction_x = 1;
			direction_y = 1;
			r = 0;
			break;
	}
	
	// Setup buttons
	DDRD &= ~(1 << PD0);
	PORTD |= (1 << PD0);

	DDRD &= ~(1 << PD1);
	PORTD |= (1 << PD1);

	DDRD &= ~(1 << PD4);
	PORTD |= (1 << PD4);

	DDRD &= ~(1 << PD5);
	PORTD |= (1 << PD5);

	lcd_goto_xy(6, 2);
	lcd_str("Pong");
	lcd_goto_xy(2, 4);
	lcd_str("First to 10");
	_delay_ms(50000);
	while (1){

		ball_x += direction_x;
		ball_y += direction_y;
		if (ball_y >= 6)
			direction_y = -1;
		if (ball_y <= 1)
			direction_y = 1;
		if (ball_x >= 14){
			if (ball_y == player2_y || ball_y == player2_y - 1 || ball_y == player2_y + 1){
				direction_x *= (-1);
			}
			else{
				ball_x = 7;
				ball_y = 3;
				score_1 ++;
				if (score_1 == 10){
					lcd_clear();
					lcd_goto_xy(2, 2);
					lcd_str("Player 1 won!");
					break;
				}
				switch(r){
					case 0:
						direction_x = -1;
						direction_y = -1;
						r = 1;
						break;
					case 1:
						direction_x = -1;
						direction_y = 1;
						r = 2;
						break;
					case 2:
						direction_x = 1;
						direction_y = -1;
						r = 3;
						break;
					case 3:
						direction_x = 1;
						direction_y = 1;
						r = 0;
						break;
				}
			}
		}
		else if (ball_x <= 1){
			if (ball_y == player1_y || ball_y == player1_y - 1 || ball_y == player1_y + 1){
				direction_x *= (-1);
			}
			else{
				ball_x = 7;
				ball_y = 3;
				score_2 ++;
				if (score_2 == 10){
					lcd_clear();
					lcd_goto_xy(2, 2);
					lcd_str("Player 2 won!");
					break;
				}
				switch(r){
					case 0:
						direction_x = -1;
						direction_y = -1;
						r = 1;
						break;
					case 1:
						direction_x = -1;
						direction_y = 1;
						r = 2;
						break;
					case 2:
						direction_x = 1;
						direction_y = -1;
						r = 3;
						break;
					case 3:
						direction_x = 1;
						direction_y = 1;
						r = 0;
						break;
				}
			}		
		}
		
		_delay_ms(1000);

		// Setting platforms positions
		if ((PIND & (1 << PD0)) == 0 ){
			player2_y ++;
			if (player2_y >= 6)
				player2_y = 6;
			_delay_ms(200);
		}
		else if ((PIND & (1 << PD1)) == 0){
			player2_y --;
			if (player2_y <= 1)
				player2_y = 1;
			_delay_ms(200);
		}

		if ((PIND & (1 << PD5)) == 0 ){
			player1_y ++;
			if (player1_y >= 6)
				player1_y = 6;
			_delay_ms(200);
		}
		else if ((PIND & (1 << PD4)) == 0){
			player1_y --;
			if (player1_y <= 1)
				player1_y = 1;
			_delay_ms(200);
		}


		_delay_ms(2000);

		lcd_clear();

		// Drawing platforms
		lcd_goto_xy(1, player1_y);
		lcd_chr(LINE);
		lcd_goto_xy(14, player2_y);
		lcd_chr(LINE);
		lcd_goto_xy(3, 1);
		itoa(score_1, buffer, 10);
		lcd_str(buffer);
		lcd_goto_xy(12, 1);
		itoa(score_2, buffer, 10);
		lcd_str(buffer);

		// Drawing ball
		lcd_goto_xy(ball_x, ball_y);
		lcd_chr(BALL);
	}
		

}
